#---Rscript dp run some test data for count data with glm
.libPaths("C:/Users/Public/Rlib")
setwd("C:/Users/rx01/teach/countglm2020")

library(randomNames)

#====normal distribution
normtest <- rnorm(2000,mean = 0, sd = 3)
hist(normtest)
qqnorm(normtest)
qqline(normtest, col = "blue", lwd = 2)

#======plant suvival VS temperature 
(testdt <- data.frame(temp.C=c(15,20,25,30,35,40,45),
                     No.dead=c(1,1,2,5,8,10,10),
                     proportion=c(0.1,0.1,0.2,0.5,0.8,1.0,1.0)
                     ) )

#---an ordinary linear model
(olm.res<- lm(proportion ~ temp.C,testdt))
summary(olm.res)

#---check qqplot of lm results
plot(olm.res,which=2)

#---normalised y with ordinary linear model
(normY.olm.res <- lm(asin(sqrt(proportion)) ~ temp.C,testdt))
summary(normY.olm.res)

#---check qqplot of lm with nromalised Y
plot(normY.olm.res,which=2)

#---generalised linear model---(many ways to fit this model!!!)
head(testdt)
glm.res <- glm(proportion ~ temp.C, data = testdt, 
               family = binomial(link="logit"), weights = No.dead/proportion)
summary(glm.res)
plot(glm.res,which=2)

#============sex and uni data=============
#---create data-----
(sudt <- data.frame(Name=c(randomNames(100,'Male',which.names="first"),randomNames(100,'Female',which.names="first")),
                   Sex=c(rep('Male',100),rep('Female',100)),
                   University=c(rep('GoesToUni',50),rep('DoesNot',50),rep('GoesToUni',80),rep('DoesNot',20))
           )
)
head(sudt)
dim(sudt)

#---create contingency table
(cont.tab <- t(table(sudt[,-1])))

#---chi-squre test on contingency table
chisq.res <- chisq.test(cont.tab)
chisq.res
chisq.res$observed
chisq.res$expected

#---generalised linear model to contingency table (there are many ways to fit!!!)
#-fit binomial distribution
su.glm.res.b <- glm(University ~ Sex, weights = Freq, data = cont.tab, family = binomial)
summary(su.glm.res.b)

#-fit poisson distribution, note that the main effect of sex in the binomial model 
#is supposed to be the interaction between sex and Uni in the poisson model
su.glm.res.p <- glm(Freq ~ University + Sex + University*Sex, data = cont.tab, 
                    family = poisson)
summary(su.glm.res.p)

#----note the main effects from the binomial model == the interaction from the poisson model
glm.cbcoef <- rbind(data.frame(data.frame(summary(su.glm.res.b)$coefficients),
                               method=unlist(summary(su.glm.res.b)$family[1])),
                    data.frame(data.frame(summary(su.glm.res.p)$coefficients),
                               method=unlist(summary(su.glm.res.p)$family[1])))
glm.cbcoef
#========but binomial model is simpler============
